using System;
using System.Numerics;

using Microsoft.UI.Composition;
using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Input;
using Microsoft.UI.Xaml.Media;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ռ
        /// </summary>
        private Compositor compositor = CompositionTarget.GetCompositorForCurrentThread();

        /// <summary>
        ///  3 ڿ  ִϸ̼
        /// </summary>
        private SpringVector3NaturalMotionAnimation springAnimation;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            Loaded                         += Page_Loaded;
            this.itemButton.PointerEntered += itemButton_PointerEntered;
            this.itemButton.PointerExited  += itemButton_PointerExited;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region  ε óϱ - Page_Loaded(sender, e)

        /// <summary>
        ///  ε óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void Page_Loaded(object sender, RoutedEventArgs e)
        {
            UpdateSpringAnimation(1.0f);
        }

        #endregion
        #region ׸ ư  Խ óϱ - itemButton_PointerEntered(sender, e)

        /// <summary>
        /// ׸ ư  Խ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void itemButton_PointerEntered(object sender, PointerRoutedEventArgs e)
        {
            UpdateSpringAnimation(1.5f);

            (sender as UIElement).StartAnimation(this.springAnimation);
        }

        #endregion
        #region ׸ ư  Ż óϱ - itemButton_PointerExited(sender, e)

        /// <summary>
        /// ׸ ư  Ż óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void itemButton_PointerExited(object sender, PointerRoutedEventArgs e)
        {
            UpdateSpringAnimation(1f);

            (sender as UIElement).StartAnimation(this.springAnimation);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region   ϱ - GetDampingRatio()

        /// <summary>
        ///   ϱ
        /// </summary>
        /// <returns> </returns>
        private float GetDampingRatio()
        {
            if(this.dampingRadioButtons.SelectedItem != null)
            {
                return (float)Convert.ToDouble((this.dampingRadioButtons.SelectedItem as RadioButton).Content);
            }

            return 0.6f;
        }

        #endregion
        #region Ⱓ ϱ - GetPeriod()

        /// <summary>
        /// Ⱓ ϱ
        /// </summary>
        /// <returns>Ⱓ</returns>
        private TimeSpan GetPeriod()
        {
            return TimeSpan.FromMilliseconds(this.periodSlider.Value);
        }

        #endregion
        #region  ִϸ̼ Ʈϱ - UpdateSpringAnimation(finalValue)

        /// <summary>
        ///  ִϸ̼ Ʈϱ
        /// </summary>
        /// <param name="finalValue"> </param>
        private void UpdateSpringAnimation(float finalValue)
        {
            if(this.springAnimation == null)
            {
                this.springAnimation = this.compositor.CreateSpringVector3Animation();

                this.springAnimation.Target = "Scale";
            }

            this.springAnimation.FinalValue   = new Vector3(finalValue);
            this.springAnimation.DampingRatio = GetDampingRatio();
            this.springAnimation.Period       = GetPeriod();
        }

        #endregion
    }
}